from aws_lambda_powertools import Logger
from aws_lambda_powertools.utilities.data_classes import (
    EventBridgeEvent,
    event_source,
)
from aws_lambda_powertools.utilities.typing import LambdaContext
from layercake.dateutils import now
from layercake.dynamodb import (
    DynamoDBPersistenceLayer,
    KeyPair,
)

from boto3clients import dynamodb_client
from config import ORDER_TABLE

logger = Logger(__name__)
order_layer = DynamoDBPersistenceLayer(ORDER_TABLE, dynamodb_client)


@event_source(data_class=EventBridgeEvent)
@logger.inject_lambda_context
def lambda_handler(event: EventBridgeEvent, context: LambdaContext) -> bool:
    """Set to `PAID` if the status is `PENDING` and the total is zero."""
    new_image = event.detail['new_image']
    now_ = now()

    with order_layer.transact_writer() as transact:
        transact.update(
            key=KeyPair(new_image['id'], '0'),
            update_expr='SET #status = :status, updated_at = :updated_at',
            expr_attr_names={
                '#status': 'status',
            },
            expr_attr_values={
                ':status': 'PAID',
                ':updated_at': now_,
            },
        )
        transact.put(
            item={
                'id': new_image['id'],
                'sk': 'paid_at',
                'paid_at': now_,
            }
        )

    return True
